=== debian/changelog ===
orcania (2.3.2-1) unstable; urgency=medium

  * New upstream release
  * d/control: Update Standards-Version to 4.6.2
  * d/liborcania-dev.install: Add cmake dependencies
  * d/copyright: Update copyright year to 2023 for debian/* files

 -- Nicolas Mora <babelouest@debian.org>  Thu, 05 Jan 2023 16:33:59 -0500

orcania (2.3.1-1) unstable; urgency=medium

  * New upstream release
  * d/control: Update Standards-Version to 4.6.1

 -- Nicolas Mora <babelouest@debian.org>  Sat, 15 Oct 2022 17:12:34 -0400
