=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- $(ARGS) -DBUILD_ORCANIA_TESTING=on\
	                             -DINSTALL_HEADER=on\
	                             -DBUILD_BASE64URL=off\
	                             --no-warn-unused-cli

override_dh_auto_build:
	doxygen doc/doxygen.cfg
	dh_auto_build --
