=== src/Makefile ===
--- 
+++ 
@@ -34,7 +34,7 @@
 OUTPUT=liborcania.so
 VERSION_MAJOR=2
 VERSION_MINOR=3
-VERSION_PATCH=2
+VERSION_PATCH=3
 OBJECTS=orcania.o memory.o base64.o
 LIBSDEP=-lm
 LIBS=-lc
