=== debian/changelog ===
orcania (2.3.3-1) unstable; urgency=medium

  * New upstream release
  * d/patches: Add patch to fix doxygen warning
  * d/rules: remove doc/html during dh_clean (Closes: #1048574)

 -- Nicolas Mora <babelouest@debian.org>  Wed, 20 Sep 2023 07:35:37 -0400
