=== debian/rules ===
--- 
+++ 
@@ -21,3 +21,7 @@
 override_dh_auto_build:
 	doxygen doc/doxygen.cfg
 	dh_auto_build --
+
+override_dh_auto_clean:
+	rm -rf doc/html
+	dh_auto_clean --
